package com.tv.adsdkdemo.Activity;

import android.app.Activity;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.support.annotation.Nullable;
import android.util.Log;
import android.view.KeyEvent;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.widget.RelativeLayout;
import com.dangbei.euthenia.manager.DangbeiAdManager;
import com.dangbei.euthenia.manager.OnAdDisplayListener;
import com.dangbei.euthenia.manager.OnAdDisplayListenerAdapter;
import com.dangbei.euthenia.ui.IAdContainer;
import com.tv.adsdkdemo.EutheniaUtil;
import com.tv.adsdkdemo.R;
import com.tv.adsdkdemo.video.MNViderPlayer;
import com.tv.adsdkdemo.video.MNViderPlayer.OnProgressListener;
import com.tv.adsdkdemo.video.MNViderPlayer.OnStartOrPauseListener;

/**
 * 创建人：zxh
 * 创建时间：2017/6/12 下午1:27
 */
public class PauseAdActivity extends Activity {

    private static final String TAG = PauseAdActivity.class.getSimpleName();

    private final String url = "http://ks3-cn-beijing.ksyun.com/dangbeisvdm3u8/ks1/yy/2017060204/99a129cd3154f74acabf.m3u8";
    private MNViderPlayer mnViderPlayer;
    RelativeLayout videoParentView;
    RelativeLayout pauseAdParentView;
    IAdContainer adContainer;

    boolean isFullscreen;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pause_image_ad);
        videoParentView = (RelativeLayout) findViewById(R.id.activity_pause_image_ad_container_rl);
        ViewGroup.LayoutParams layoutParams = videoParentView
                .getLayoutParams();
        if (layoutParams == null) {
            layoutParams = new RelativeLayout.LayoutParams(960, 540);
        }
        layoutParams.width = 960;
        layoutParams.height = 540;
        videoParentView.setLayoutParams(layoutParams);


        initPlayer();

    }

    private void initPlayer() {
        mnViderPlayer = new MNViderPlayer(this);
        LayoutParams layoutParams = mnViderPlayer.getLayoutParams();
        if (layoutParams == null) {
            layoutParams = new RelativeLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);
        }
        layoutParams.width = LayoutParams.MATCH_PARENT;
        layoutParams.height = LayoutParams.MATCH_PARENT;
        mnViderPlayer.setLayoutParams(layoutParams);
        videoParentView.addView(mnViderPlayer);
        //第一次进来先设置数据
        mnViderPlayer.setDataSource(url);
        //播放完成监听
        mnViderPlayer.setOnCompletionListener(new MNViderPlayer.OnCompletionListener() {
            @Override
            public void onCompletion(MediaPlayer mediaPlayer) {
                Log.i(TAG, "播放完成----");
            }
        });
        mnViderPlayer.setOnProgressListener(new OnProgressListener() {
            @Override
            public void onProgress(int seconds) {
            }
        });
        mnViderPlayer.setOnStartOrPauseListener(new OnStartOrPauseListener() {
            @Override
            public void onStart() {
                /**
                 * 5.播放器从暂停到播放的时候，调用close方法。
                 */
                if (EutheniaUtil.attachedAd(adContainer)) {
                    adContainer.close();
                }
            }

            @Override
            public void onPause() {
                if (isFullscreen) {
                    /**
                     * 1.创建广告
                     */
                    adContainer = DangbeiAdManager.getInstance()
                            .createVideoPauseAdContainer(PauseAdActivity.this);
                    /**
                     * 2.请设置pauseAdParentView位置为centerInParent，pauseAdParentView的大小就是暂停广告的大小
                     */
                    pauseAdParentView = (RelativeLayout) findViewById(R.id.activity_pause_image_ad_pause_container_rl);
                    LayoutParams layoutParams = pauseAdParentView
                            .getLayoutParams();
                    if (layoutParams == null) {
                        layoutParams = new RelativeLayout.LayoutParams(960, 540);
                    }
                    layoutParams.width = 960;
                    layoutParams.height = 540;
                    pauseAdParentView.setLayoutParams(layoutParams);
                    adContainer.setParentView(pauseAdParentView);
                    adContainer.setOnAdDisplayListener(new OnAdDisplayListener() {
                        @Override
                        public void onDisplaying() {
                            Log.e(TAG, "onDisplaying");

                        }

                        @Override
                        public void onFailed(Throwable throwable) {
                            Log.e(TAG, "onFailed:" + throwable.toString());

                        }

                        @Override
                        public void onFinished() {
                            Log.e(TAG, "onFinished");


                        }

                        @Override
                        public void onClosed() {
                            Log.e(TAG, "onClosed");


                        }

                        @Override
                        public void onTerminated() {
                            Log.e(TAG, "onTerminated");


                        }

                        @Override
                        public void onSkipped() {
                            Log.e(TAG, "onSkipped");

                        }

                        @Override
                        public void onTriggered() {
                            Log.e(TAG, "onTriggered");


                        }
                    });
                    /**
                     * 3.调用open方法打开广告，调用close关闭
                     */
                    adContainer.open();
                }
            }
        });
        new Handler().postDelayed(new Runnable() {
            @Override
            public void run() {
                mnViderPlayer.playVideo();
            }
        }, 100);
    }

    @Override
    protected void onPause() {
        super.onPause();
        mnViderPlayer.pauseVideo();
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onDestroy() {
        //一定要记得销毁View
        if (mnViderPlayer != null) {
            mnViderPlayer.destroyVideo();
            mnViderPlayer = null;
        }
        super.onDestroy();
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        boolean interruptKeyEvent = EutheniaUtil.isVideoPauseAdDispatchEventToAd(adContainer);
        Log.e(TAG, "interruptKeyEvent:" + interruptKeyEvent);
        if (interruptKeyEvent) {
            return super.dispatchKeyEvent(event);
        }
        if (event.getAction() == KeyEvent.ACTION_DOWN) {
            switch (event.getKeyCode()) {
                case KeyEvent.KEYCODE_DPAD_CENTER:
                case KeyEvent.KEYCODE_ENTER:
                    if (isFullscreen) {
                        mnViderPlayer.startOrPause();
                    } else {
                        resizeVideoView();
                    }
                    return true;
                case KeyEvent.KEYCODE_DPAD_RIGHT:
                    mnViderPlayer.forward();
                    return true;
                case KeyEvent.KEYCODE_DPAD_LEFT:
                    mnViderPlayer.backward();
                    return true;
                case KeyEvent.KEYCODE_BACK:
                    if (mnViderPlayer.isFullScreen()) {
                        /**
                         * 4.退出全屏的时候，如果暂停广告在展示，调用close方法关闭广告
                         */
                        if (EutheniaUtil.attachedAd(adContainer)) {
                            adContainer.close();
                        }
                        resizeVideoView();
                    } else {
                        finish();
                    }
                    return true;
            }
        }
        return super.dispatchKeyEvent(event);
    }

    public void resizeVideoView() {
        if (isFullscreen) {
            ViewGroup.LayoutParams layoutParams = videoParentView
                    .getLayoutParams();
            if (layoutParams == null) {
                layoutParams = new RelativeLayout.LayoutParams(960, 540);
            }
            layoutParams.width = 960;
            layoutParams.height = 540;
            videoParentView.setLayoutParams(layoutParams);

        } else {
            ViewGroup.LayoutParams layoutParams = mnViderPlayer.getLayoutParams();
            if (layoutParams == null) {
                layoutParams = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
            }
            layoutParams.width = ViewGroup.LayoutParams.MATCH_PARENT;
            layoutParams.height = ViewGroup.LayoutParams.MATCH_PARENT;
            videoParentView.setLayoutParams(layoutParams);
        }
        isFullscreen = !isFullscreen;

    }


    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case KeyEvent.KEYCODE_DPAD_LEFT:
            case KeyEvent.KEYCODE_DPAD_RIGHT:
                mnViderPlayer.seekTo();
                break;
        }
        return super.onKeyUp(keyCode, event);
    }
}
