package com.tv.adsdkdemo.Activity;

import android.app.Activity;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.support.annotation.Nullable;
import android.util.Log;
import android.view.KeyEvent;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.widget.RelativeLayout;
import com.dangbei.euthenia.manager.DangbeiAdManager;
import com.dangbei.euthenia.manager.OnAdDisplayListener;
import com.dangbei.euthenia.ui.IAdContainer;
import com.tv.adsdkdemo.EutheniaUtil;
import com.tv.adsdkdemo.R;
import com.tv.adsdkdemo.video.MNViderPlayer;
import com.tv.adsdkdemo.video.MNViderPlayer.OnProgressListener;

/**
 * 创建人：zxh
 * 创建时间：2017/6/12 下午5:17
 */
public class VideoFloatAdActivity extends Activity {

    private static final String TAG = VideoFloatAdActivity.class.getSimpleName();


    private final String url = "http://ks3-cn-beijing.ksyun.com/dangbeisvdm3u8/ks1/yy/2017060204/99a129cd3154f74acabf.m3u8";
    private MNViderPlayer mnViderPlayer;
    RelativeLayout videoParentView;
    RelativeLayout floatAdParentView;
    IAdContainer adContainer;

    boolean isFullscreen;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_video_float_ad);
        videoParentView = (RelativeLayout) findViewById(R.id.activity_video_float_ad_container_rl);
        ViewGroup.LayoutParams layoutParams = videoParentView
                .getLayoutParams();
        if (layoutParams == null) {
            layoutParams = new RelativeLayout.LayoutParams(960, 540);
        }
        layoutParams.width = 960;
        layoutParams.height = 540;
        videoParentView.setLayoutParams(layoutParams);

        initPlayer();


    }

    private void initPlayer() {
        mnViderPlayer = new MNViderPlayer(this);
        LayoutParams layoutParams = mnViderPlayer.getLayoutParams();
        if (layoutParams == null) {
            layoutParams = new RelativeLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);
        }
        layoutParams.width = LayoutParams.MATCH_PARENT;
        layoutParams.height = LayoutParams.MATCH_PARENT;
        mnViderPlayer.setLayoutParams(layoutParams);
        videoParentView.addView(mnViderPlayer);
        //第一次进来先设置数据
        mnViderPlayer.setDataSource(url);
        //播放完成监听
        mnViderPlayer.setOnCompletionListener(new MNViderPlayer.OnCompletionListener() {
            @Override
            public void onCompletion(MediaPlayer mediaPlayer) {
                Log.i(TAG, "播放完成----");
            }
        });
        mnViderPlayer.setOnProgressListener(new OnProgressListener() {
            @Override
            public void onProgress(int seconds) {
                if (seconds == 4 && isFullscreen) {
                    /**
                     * 1.创建广告
                     */
                    adContainer = DangbeiAdManager.getInstance()
                            .createVideoFloatAdContainer(VideoFloatAdActivity.this);
                    /**
                     * 2.设置setParentView为floatAdParentView（必须为RelativeLayoutw），广告view出现在floatAdParentView的右下角，大小为素材的大小。
                     */
                    floatAdParentView = (RelativeLayout) findViewById(R.id.activity_video_float_ad_float_container_rl);
                    adContainer.setParentView(floatAdParentView);
                    adContainer.setOnAdDisplayListener(new OnAdDisplayListener() {
                        @Override
                        public void onDisplaying() {
                            Log.e(TAG, "onDisplaying");

                        }

                        @Override
                        public void onFailed(Throwable throwable) {
                            Log.e(TAG, "onFailed:" + throwable.toString());

                        }

                        @Override
                        public void onFinished() {
                            Log.e(TAG, "onFinished");


                        }

                        @Override
                        public void onClosed() {
                            Log.e(TAG, "onClosed");


                        }

                        @Override
                        public void onTerminated() {
                            Log.e(TAG, "onTerminated");


                        }

                        @Override
                        public void onSkipped() {
                            Log.e(TAG, "onSkipped");

                        }

                        @Override
                        public void onTriggered() {
                            Log.e(TAG, "onTriggered");


                        }
                    });
                    /**
                     * 3.调用打开，自动关闭。
                     */
                    adContainer.open();
                }
            }
        });
        new Handler().postDelayed(new Runnable() {
            @Override
            public void run() {
                mnViderPlayer.playVideo();
            }
        }, 100);
    }

    @Override
    protected void onPause() {
        super.onPause();
        mnViderPlayer.pauseVideo();
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onDestroy() {
        //一定要记得销毁View
        if (mnViderPlayer != null) {
            mnViderPlayer.destroyVideo();
            mnViderPlayer = null;
        }
        super.onDestroy();
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        boolean interruptKeyEvent = EutheniaUtil.isVideoFloatAdDispatchEventToAd(adContainer);
        Log.e(TAG, "interruptKeyEvent:" + interruptKeyEvent);
        if (interruptKeyEvent) {
            return super.dispatchKeyEvent(event);
        }

        if (event.getAction() == KeyEvent.ACTION_DOWN) {
            switch (event.getKeyCode()) {
                case KeyEvent.KEYCODE_DPAD_CENTER:
                case KeyEvent.KEYCODE_ENTER:
                    if (isFullscreen) {
                        mnViderPlayer.startOrPause();
                    } else {
                        resizeVideoView();
                    }
                    return true;
                case KeyEvent.KEYCODE_DPAD_RIGHT:
                    mnViderPlayer.forward();
                    return true;
                case KeyEvent.KEYCODE_DPAD_LEFT:
                    mnViderPlayer.backward();
                    return true;
                case KeyEvent.KEYCODE_BACK:
                    if (mnViderPlayer.isFullScreen()) {
                        resizeVideoView();
                    } else {
                        finish();
                    }
                    return true;
            }
        }
        return super.dispatchKeyEvent(event);
    }

    public void resizeVideoView() {
        if (isFullscreen) {
            ViewGroup.LayoutParams layoutParams = videoParentView
                    .getLayoutParams();
            if (layoutParams == null) {
                layoutParams = new RelativeLayout.LayoutParams(960, 540);
            }
            layoutParams.width = 960;
            layoutParams.height = 540;
            videoParentView.setLayoutParams(layoutParams);

        } else {
            ViewGroup.LayoutParams layoutParams = mnViderPlayer.getLayoutParams();
            if (layoutParams == null) {
                layoutParams = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
            }
            layoutParams.width = ViewGroup.LayoutParams.MATCH_PARENT;
            layoutParams.height = ViewGroup.LayoutParams.MATCH_PARENT;
            videoParentView.setLayoutParams(layoutParams);
        }
        isFullscreen = !isFullscreen;
    }

    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case KeyEvent.KEYCODE_DPAD_LEFT:
            case KeyEvent.KEYCODE_DPAD_RIGHT:
                mnViderPlayer.seekTo();
                break;
        }
        return super.onKeyUp(keyCode, event);
    }
}
