package com.tv.adsdkdemo.Activity;

import android.app.Activity;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.util.Log;
import android.view.KeyEvent;
import android.view.ViewGroup;
import android.view.ViewGroup.LayoutParams;
import android.widget.RelativeLayout;
import com.dangbei.euthenia.manager.DangbeiAdManager;
import com.dangbei.euthenia.manager.OnAdDisplayListener;
import com.dangbei.euthenia.ui.IAdContainer;
import com.tv.adsdkdemo.EutheniaUtil;
import com.tv.adsdkdemo.R;
import com.tv.adsdkdemo.video.MNViderPlayer;
import com.tv.adsdkdemo.video.MNViderPlayer.OnProgressListener;

/**
 * 创建人：zxh
 * 创建时间：2017/6/9 下午5:38
 */
public class VideoPreAdActivity extends Activity {

    private static final String TAG = VideoPreAdActivity.class.getSimpleName();


    private final String url = "http://ks3-cn-beijing.ksyun.com/dangbeisvdm3u8/ks1/yy/2017060204/99a129cd3154f74acabf.m3u8";
    private MNViderPlayer mnViderPlayer;
    RelativeLayout videoParentView;
    IAdContainer adContainer;
    boolean isFullscreen;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_video_pre_ad);
        videoParentView = (RelativeLayout) findViewById(R.id.activity_video_pre_ad_container_rl);
        ViewGroup.LayoutParams layoutParams = videoParentView
                .getLayoutParams();
        if (layoutParams == null) {
            layoutParams = new RelativeLayout.LayoutParams(960, 540);
        }
        layoutParams.width = 960;
        layoutParams.height = 540;
        videoParentView.setLayoutParams(layoutParams);
        initPlayer();

        /**
         * 1.创建广告
         */
        adContainer = DangbeiAdManager.getInstance()
                .createVideoPreAdContainer(this);
        /**
         * 2.由于贴片广告的大小和视频一样大，所以可以和VideoView使用同一个videoParentView
         */
        adContainer.setParentView(videoParentView);
        adContainer.setOnAdDisplayListener(new OnAdDisplayListener() {
            @Override
            public void onDisplaying() {
                Log.e(TAG, "onDisplaying");

            }

            @Override
            public void onFailed(Throwable throwable) {
                Log.e(TAG, "onFailed:" + throwable.toString());
                if (mnViderPlayer != null) {
                    mnViderPlayer.playVideo();
                }
            }

            @Override
            public void onFinished() {
                Log.e(TAG, "onFinished");
                if (mnViderPlayer != null) {
                    mnViderPlayer.playVideo();
                }

            }

            @Override
            public void onClosed() {
                Log.e(TAG, "onClosed");
                if (mnViderPlayer != null) {
                    mnViderPlayer.playVideo();
                }

            }

            @Override
            public void onTerminated() {
                Log.e(TAG, "onTerminated");
                if (mnViderPlayer != null) {
                    mnViderPlayer.playVideo();
                }

            }

            @Override
            public void onSkipped() {
                Log.e(TAG, "onSkipped");
                if (mnViderPlayer != null) {
                    mnViderPlayer.playVideo();
                }
            }

            @Override
            public void onTriggered() {
                Log.e(TAG, "onTriggered");
                if (mnViderPlayer != null) {
                    mnViderPlayer.playVideo();
                }

            }
        });
        /**
         * 3.调用打开，自动关闭。
         */
        adContainer.open();

    }

    private void initPlayer() {
        mnViderPlayer = new MNViderPlayer(this);
        LayoutParams layoutParams = mnViderPlayer.getLayoutParams();
        if (layoutParams == null) {
            layoutParams = new RelativeLayout.LayoutParams(LayoutParams.MATCH_PARENT, LayoutParams.MATCH_PARENT);
        }
        layoutParams.width = LayoutParams.MATCH_PARENT;
        layoutParams.height = LayoutParams.MATCH_PARENT;
        mnViderPlayer.setLayoutParams(layoutParams);
        videoParentView.addView(mnViderPlayer);
        //第一次进来先设置数据
        mnViderPlayer.setDataSource(url);
        //播放完成监听
        mnViderPlayer.setOnCompletionListener(new MNViderPlayer.OnCompletionListener() {
            @Override
            public void onCompletion(MediaPlayer mediaPlayer) {
                Log.i(TAG, "播放完成----");
            }
        });
        mnViderPlayer.setOnProgressListener(new OnProgressListener() {
            @Override
            public void onProgress(int seconds) {
                Log.i(TAG, "当前多少秒：" + seconds);
            }
        });

    }

    @Override
    protected void onPause() {
        super.onPause();
        mnViderPlayer.pauseVideo();
    }

    @Override
    protected void onResume() {
        super.onResume();
    }

    @Override
    protected void onDestroy() {
        //一定要记得销毁View
        if (mnViderPlayer != null) {
            mnViderPlayer.destroyVideo();
            mnViderPlayer = null;
        }
        super.onDestroy();
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        /**
         * 4.注意，由于广告需要控制Event，请调用下面方法。
         */
        boolean isDispatchEventToAd = EutheniaUtil.isVideoPrAdDispatchEventToAd(adContainer, isFullscreen, event);
        Log.e("zxh", "interruptKeyEvent:" + isDispatchEventToAd);
        if (isDispatchEventToAd) {
            return super.dispatchKeyEvent(event);
        }

        if (event.getAction() == KeyEvent.ACTION_DOWN) {
            switch (event.getKeyCode()) {
                case KeyEvent.KEYCODE_DPAD_CENTER:
                case KeyEvent.KEYCODE_ENTER:

                    if (isFullscreen) {
                        mnViderPlayer.startOrPause();
                    } else {
                        resizeVideoView();
                        /**
                         * 5.当videoview的大小发生改变的时候，请调用EutheniaUtil.resizeAd(adContainer);
                         */
                        EutheniaUtil.resizeAd(adContainer);
                    }
                    return true;
                case KeyEvent.KEYCODE_DPAD_RIGHT:
                    mnViderPlayer.forward();
                    return true;
                case KeyEvent.KEYCODE_DPAD_LEFT:
                    mnViderPlayer.backward();
                    return true;
                case KeyEvent.KEYCODE_BACK:
                    if (mnViderPlayer.isFullScreen()) {
                        resizeVideoView();
                        /**
                         * 5.当videoview的大小发生改变的时候，请调用EutheniaUtil.resizeAd(adContainer);
                         */
                        EutheniaUtil.resizeAd(adContainer);
                    } else {
                        finish();
                    }
                    return true;
            }
        }
        return super.dispatchKeyEvent(event);
    }

    public void resizeVideoView() {
        if (isFullscreen) {
            ViewGroup.LayoutParams layoutParams = videoParentView
                    .getLayoutParams();
            if (layoutParams == null) {
                layoutParams = new RelativeLayout.LayoutParams(960, 540);
            }
            layoutParams.width = 960;
            layoutParams.height = 540;
            videoParentView.setLayoutParams(layoutParams);

        } else {
            ViewGroup.LayoutParams layoutParams = mnViderPlayer.getLayoutParams();
            if (layoutParams == null) {
                layoutParams = new RelativeLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
            }
            layoutParams.width = ViewGroup.LayoutParams.MATCH_PARENT;
            layoutParams.height = ViewGroup.LayoutParams.MATCH_PARENT;
            videoParentView.setLayoutParams(layoutParams);
        }
        isFullscreen = !isFullscreen;

    }

    @Override
    public boolean onKeyUp(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case KeyEvent.KEYCODE_DPAD_LEFT:
            case KeyEvent.KEYCODE_DPAD_RIGHT:
                mnViderPlayer.seekTo();
                break;
        }
        return super.onKeyUp(keyCode, event);
    }
}
